<template>
  <div class="goodsCost pagePadding">
    <ex-table
      v-loading="loading"
      v-if="powers && powers.length > 0 && powers.some((item) => item == '001')"
      :table="table"
      :data="tableData"
      :columns="columns"
      :page="pageInfo"
      :size="size"
      @page-curr-change="handlePageChange"
      @page-size-change="handleSizeChange"
      @screen-reset="
        pageInfo.curr = 1;
        parmValue.page = 1;
        searchList();
      "
      @screen-submit="
        pageInfo.curr = 1;
        parmValue.page = 1;
        searchList();
      "
    >
      <template #table-header="{}">
        <div style="width: 100%">
          <el-row style="padding: 0 0 10px 80px">
            <el-col :span="6" style="width: 303px">
              <period-date-picker
                :type="1"
                :width="'135px'"
                :size="searchSize"
                :start="parmValue.start"
                :end="parmValue.end"
                @timeReturned="handleTime"
              />
            </el-col>
            <el-col :span="4" style="width: 135px">
              <search-brand
                :value="brandid"
                :disabled="false"
                :size="'mini'"
                :isDetail="false"
                :names="''"
                :placeholder="'商品品牌'"
                @searchChange="brandidsearchChange"
              />
            </el-col>
            <el-col :span="6" style="width: 310px; padding: 0 0 0 10px">
              <good-class
                :value="parmValue.cat_id"
                @handleChange="goods_class_change"
                :disabled="false"
                :size="searchSize"
                :isDetail="false"
                :placeholder="'分类'"
              />
            </el-col>

            <el-col
              :span="3"
              class="fr"
              style="width: 66px; padding: 0 0 0 10px"
            >
              <el-button type="primary" :size="searchSize" @click="searchList">
                刷新
              </el-button>
            </el-col>
            <el-col
              :span="3"
              class="fr"
              style="width: 66px; padding: 0 0 0 10px"
            >
              <el-button type="warning" :size="searchSize" @click="restSearch">
                重置
              </el-button>
            </el-col>
          </el-row>
          <el-row>
            <el-col :span="4" style="width: 226px">
              <el-select
                v-model="parmValue.status"
                filterable
                clearable
                :size="searchSize"
                placeholder="状态"
                style="width: 100%"
                @change="
                  pageInfo.curr = 1;
                  parmValue.page = 1;
                  searchList();
                "
              >
                <el-option
                  v-for="item in statusList"
                  :key="'status' + item.code"
                  :label="item.name"
                  :value="item.code"
                />
              </el-select>
            </el-col>
            <el-col :span="4" style="width: 145px; padding: 0 0 0 10px">
              <el-select
                v-model="parmValue.good_type"
                filterable
                clearable
                :size="searchSize"
                placeholder="是否定制"
                style="width: 100%"
                @change="
                  pageInfo.curr = 1;
                  parmValue.page = 1;
                  searchList();
                "
              >
                <el-option
                  v-for="item in options1"
                  :key="'good_type' + item.id"
                  :label="item.name"
                  :value="item.id"
                />
              </el-select>
            </el-col>
            <el-col :span="4" style="width: 450px; padding: 0 0 0 10px">
              <el-input
                :size="searchSize"
                v-model="sinput"
                :maxlength="40"
                @blur="
                  pageInfo.curr = 1;
                  parmValue.page = 1;
                  searchList();
                "
                placeholder="关键字"
                ><el-select
                  v-model="select"
                  slot="prepend"
                  style="width: 135px"
                  placeholder="关键字类型"
                >
                  <el-option label="商品编号" value="1" />
                  <el-option label="商品名称" value="2" />
                  <el-option label="业务企业编号" value="3" />
                  <el-option label="供应商编号" value="4" /> </el-select
              ></el-input>
            </el-col>

            <el-col
              :span="3"
              class="fr"
              style="width: 66px; padding: 0 0 0 10px"
              v-if="powers.some((item) => item == '003')"
            >
              <el-button
                :size="searchSize"
                type="success"
                style="float: right"
                @click="
                  routeGoto('goodsCostDetail', { id: 'add', type: 'add' })
                "
              >
                添加
              </el-button>
            </el-col>
          </el-row>
        </div></template
      >

      <template #good_thumb_img="{ scope }">
        <div
          v-if="scope.row.good_thumb_img"
          style="width: 20px; height: 20px"
          class="hover"
          v-viewer
        >
          <img
            :src="scope.row.good_thumb_img"
            style="display: inline-block; width: 100%; height: 100%"
            alt=""
          />
        </div>
      </template>
      <template #status="{ scope }">
        <el-tag
          :size="tablebtnSize"
          :type="scope.row.status == '1' ? '' : 'warning'"
          v-text="
            (statusList.find((item) => item.code == scope.row.status) || {})
              .name || '--'
          "
        ></el-tag>
      </template>
      <template #good_type="{ scope }">
        <el-tag
          :size="tablebtnSize"
          :type="scope.row.good_type == '0' ? 'warning' : ''"
          v-text="
            (options1.find((item) => item.id == scope.row.good_type) || {})
              .name || '--'
          "
        ></el-tag>
      </template>

      <template #operation="{ scope }">
        <el-tooltip
          v-if="powers.some((item) => item == '007')"
          effect="dark"
          content="详情"
          placement="top"
        >
          <i
            class="el-icon-view tb-icon"
            @click="
              routeGoto('goodsCostDetail', {
                id: scope.row.spuCode,
                type: 'view',
              })
            "
          ></i>
        </el-tooltip>
        <el-tooltip
          v-if="powers.some((item) => item == '054')"
          effect="dark"
          content="修改基础信息"
          placement="top"
        >
          <i
            class="el-icon-c-scale-to-original tb-icon"
            @click="wantto(scope.row.spuCode, scope.row.status, '2')"
          ></i>
        </el-tooltip>
        <el-tooltip
          v-if="powers.some((item) => item == '053')"
          effect="dark"
          content="修改成本信息"
          placement="top"
        >
          <i
            class="el-icon-coin tb-icon"
            @click="wantto(scope.row.spuCode, scope.row.status, '3')"
          ></i>
        </el-tooltip>
        <el-tooltip
          v-if="powers.some((item) => item == '006')"
          effect="dark"
          content="删除"
          placement="top"
        >
          <i
            class="el-icon-delete tb-icon"
            @click="deleteItem(scope.row.spuCode)"
          ></i>
        </el-tooltip>
      </template>
    </ex-table>
    <no-auth v-else></no-auth>
  </div>
</template>
<script>
import asyncRequest from "@/apis/service/goodStore/goodsCost";
import mixinPage from "@/mixins/elPaginationHandle";
import { mapGetters } from "vuex";
import resToken from "@/mixins/resToken";
import { listCol, options1 } from "./columns";
export default {
  name: "goodsCost",
  mixins: [mixinPage, resToken],
  computed: {
    //组件SIZE设置
    ...mapGetters(["tablebtnSize", "searchSize", "size"]),
    powers() {
      let tran =
        this.$store.getters.btnList.find(
          (item) => item.menu_route == "goodsCost"
        ) || {};
      if (tran && tran.action && tran.action.length > 0) {
        return tran.action;
      } else {
        return [];
      }
    },
  },
  data() {
    return {
      statusList: [
        {
          code: "0",
          name: "新建待审核",
        },
        {
          code: "1",
          name: "审核通过",
        },
        {
          code: "2",
          name: "基础修改待审核",
        },
        {
          code: "3",
          name: "成本修改待审核",
        },
      ],

      options1: options1,
      loading: false,
      parmValue: {
        page: 1, // 页码
        size: 15, // 每页显示条数
        start: "",
        end: "",
        status: "",
        good_name: "",
        spucode: "",
        cat_id: [],
        brandid: "",
        good_type: "",
        companyNo: "",
        supplierNo: "",
        // creater: "",
      },
      sinput: "",
      select: "",
      // 表格 - 数据
      tableData: [],
      // 表格 - 参数
      table: {
        stripe: true,
        border: true,
        _defaultHeader_: ["setcol"],
      },
      // 表格 - 分页
      pageInfo: {
        size: 15,
        curr: 1,
        total: 0,
      },
      // 表格 - 列参数
      columns: listCol,
      supplierNo: [],
      brandid: [],
    };
  },
  mounted() {
    this.supplierNo = [];
    this.brandid = [];
    this.searchList();
  },
  methods: {
    restSearch() {
      this.supplierNo = [];
      this.brandid = [];
      // 表格 - 分页
      this.pageInfo = {
        size: 15,
        curr: 1,
        total: 0,
      };
      this.parmValue = {
        page: 1, // 页码
        size: 15, // 每页显示条数
        start: "",
        end: "",
        status: "",
        good_name: "",
        spucode: "",
        cat_id: [],
        brandid: "",
        good_type: "",
        companyNo: "",
        supplierNo: "",
      };
      this.searchList();
    },
    wantto(code, ntype, wtype) {
      if (ntype === "0") {
        this.$message.warning("新建商品成正在审核中,请审核结束后再修改！");
        return;
      }
      if (ntype === "2") {
        if (wtype === "2") {
          this.$message.warning("商品基础信息已修改,请等待审核结果！");
          return;
        }
        if (wtype === "3") {
          this.$message.warning(
            "商品基础信息修改流程正在审核中,请审核结束后再修改！"
          );
          return;
        }
      }
      if (ntype === "3") {
        if (wtype === "3") {
          this.$message.warning("商品成本信息已修改,请等待审核结果！");
          return;
        }
        if (wtype === "2") {
          this.$message.warning(
            "商品成信息修改流程正在审核中,请审核结束后再修改！"
          );
          return;
        }
      }
      console.log(ntype + "----" + wtype);
      this.routeGoto("goodsCostDetail", {
        id: code,
        type: wtype === '2' ? "editBase" : wtype === '3' ? "editCoin" : "",
      });
    },
    //商品品牌选择
    async brandidsearchChange(e) {
      const { id, code, label } = e;
      if (id) {
        this.brandid = [id];
      } else {
        this.brandid = [];
      }
      this.parmValue.brandid = this.brandid.toString();
      this.pageInfo.curr = 1;
      this.parmValue.page = 1;
      await this.searchList();
    },
    // 时间
    async handleTime(e) {
      this.parmValue.start = e.startTime || "";
      this.parmValue.end = e.endTime || "";
      if (
        (this.parmValue.start !== "" && this.parmValue.end !== "") ||
        (this.parmValue.start === "" && this.parmValue.end === "")
      ) {
        this.pageInfo.curr = 1;
        this.parmValue.page = 1;
        await this.searchList();
      }
    },
    /**
     * 启用/禁用
     * @param {String} id id
     * @param {String} status 0-禁用 1-启用
     */
    async changeStatus(id, status) {
      await this.$confirm(`确定要改为${status === "1" ? "禁用" : "启用"}？`, {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(async () => {
          this.loading = true;
          const model = {
            id: id,
            status: status === "1" ? "0" : "1",
          };
          const res = await asyncRequest.status(model);
          if (res && res.code === 0) {
            this.loading = false;
            this.$notify.success({
              title: "状态修改成功！",
              message: "",
            });
            await this.searchList();
          } else if (res && res.code >= 100 && res.code <= 104) {
            await this.logout();
          } else {
            this.loading = false;
            this.$message.warning(res.message);
          }
        })
        .catch(() => {
          console.log("取消");
        });
    },
    async deleteItem(code) {
      await this.$confirm("确定要删除？", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(async () => {
          const model = {
            codes: [code],
          };
          const res = await asyncRequest.delete(model);
          if (res && res.code === 0) {
            this.$notify.success({
              title: "删除成功",
              message: "",
            });
            this.searchList();
          } else if (res && res.code >= 100 && res.code <= 104) {
            await this.logout();
          } else {
            this.$message.warning(res.message);
          }
        })
        .catch(() => {
          console.log("取消");
        });
    },
    // 刷新表格
    async searchList() {
      this.loading = true;
      this.parmValue.spucode = this.select === "1" ? this.sinput : "";
      this.parmValue.good_name = this.select === "2" ? this.sinput : "";
      this.parmValue.companyNo = this.select === "3" ? this.sinput : "";
      this.parmValue.supplierNo = this.select === "4" ? this.sinput : "";
      let item = JSON.parse(JSON.stringify(this.parmValue));
      item.cat_id =
        item.cat_id.length > 0 ? item.cat_id[item.cat_id.length - 1] : "";
      const res = await asyncRequest.list(item);
      if (res && res.code === 0 && res.data) {
        this.tableData = res.data.list;
        this.tableData.forEach((a) => {
          a.cat_name = "";
          let list = a.cat_info || [];
          list.forEach((b, i) => {
            a.cat_name += i == 0 ? b.name : "/" + b.name;
          });
        });
        this.pageInfo.total = Number(res.data.count);
      } else if (res && res.code >= 100 && res.code <= 104) {
        await this.logout();
      } else {
        this.tableData = [];
        this.pageInfo.total = 0;
      }
      this.loading = false;
    },
    //商品分类选择
    async goods_class_change(e) {
      this.parmValue.cat_id = e;
      this.pageInfo.curr = 1;
      this.parmValue.page = 1;
      await this.searchList();
    },
  },
};
</script>

<style lang="scss" scoped>
</style>
